﻿Public Class RC4
  Private State As Byte()
  Private X, Y As Byte
  Public Sub New(key As Byte())
    State = New Byte(255) {}
    X = 0
    Y = 0
    InitKey(key)
  End Sub
  Public Function Transform(ByRef buffer As Byte(), ByRef start As Integer, count As Integer) As Integer
    Return RC4Transform(buffer, start, count, buffer, start)
  End Function
  Private Sub InitKey(key As Byte())
    Dim A As Byte = 0
    Dim B As Byte = 0
    For I As Integer = 0 To 255
      State(I) = CByte(I)
    Next
    X = 0
    Y = 0
    For counter As Integer = 0 To 255
      B = CByte(key(A) + State(counter) + B)
      Dim tmp As Byte = State(counter)
      State(counter) = State(B)
      State(B) = tmp
      A = CByte((A + 1) Mod key.Length)
    Next
  End Sub
  Private Function RC4Transform(inBuffer As Byte(), inIndex As Integer, inCount As Integer, ByRef outBuffer As Byte(), ByRef outIndex As Integer) As Integer
    For I As Integer = 0 To inCount - 1
      X = CByte(X + 1)
      Y = CByte(State(X) + Y)
      Dim tmp As Byte = State(X)
      State(X) = State(Y)
      State(Y) = tmp
      Dim xorer As Byte = CByte(State(X) + State(Y))
      outBuffer(outIndex + I) = CByte(inBuffer(inIndex + I) Xor State(xorer))
    Next
    Return inCount
  End Function
End Class