﻿Public Class frmClanInvitation
  Private Delegate Sub AddMemberCallBack([Account] As String)
  Private Delegate Sub ClearMembersCallBack()
  Private Delegate Sub CloseWindowCallBack()
  Public ClanName As String
  Public ClanTag As String
  Private Sub cmdRefresh_Click(sender As System.Object, e As System.EventArgs) Handles cmdRefresh.Click
    Dim UI As BNUI = Me.Tag
    UI.BNCS_CLANFINDCANDIDATES_Send(&H1, ClanTag)
    cmdRefresh.Enabled = False
  End Sub
  Private Sub cmdCancel_Click(sender As System.Object, e As System.EventArgs) Handles cmdCancel.Click
    Me.Close()
  End Sub
  Private Sub cmdInvite_Click(sender As System.Object, e As System.EventArgs) Handles cmdInvite.Click
    Dim UI As BNUI = Me.Tag
    Dim sNames(lstClanmates.CheckedItems.Count - 1) As String
    For I As Integer = 0 To lstClanmates.CheckedItems.Count - 1
      sNames(I) = lstClanmates.CheckedItems(I)
    Next
    UI.BNCS_CLANINVITEMULTIPLE_Send(&H1, ClanName, ClanTag, sNames)
    cmdInvite.Enabled = False
    cmdCancel.Enabled = False
  End Sub
  Public Sub AddMember([Account] As String)
    If Me.InvokeRequired Then
      Dim d As New AddMemberCallBack(AddressOf AddMember)
      Me.BeginInvoke(d, New Object() {[Account]})
    Else
      lstClanmates.Items.Add(Account)
    End If
  End Sub
  Public Sub ClearMembers()
    If Me.InvokeRequired Then
      Dim d As New ClearMembersCallBack(AddressOf ClearMembers)
      Me.BeginInvoke(d, New Object() {})
    Else
      cmdRefresh.Enabled = True
      lstClanmates.Items.Clear()
    End If
  End Sub
  Public Sub CloseWindow()
    If Me.InvokeRequired Then
      Dim d As New CloseWindowCallBack(AddressOf CloseWindow)
      Me.BeginInvoke(d, New Object() {})
    Else
      Me.Close()
    End If
  End Sub
  Private Sub lstClanmates_MouseUp(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles lstClanmates.MouseUp
    cmdInvite.Enabled = lstClanmates.CheckedItems.Count = 9
  End Sub
  Public Sub SetGui(Font As Font, BackColor As Color)
    Me.Font = Font
    lstClanmates.BackColor = BackColor
    lblTitle.Font = New Font(Font.FontFamily, Font.Size + 2, FontStyle.Bold, Font.Unit, Font.GdiCharSet, Font.GdiVerticalFont)
  End Sub
End Class